<?php


namespace App\Http\Controllers\Aguas;

use Illuminate\Support\Facades\Log;

class ConexionNodo
{
    protected $data;
    //public $url = "http://localhost:3000/nodo/api/v2";
    public $url = "http://nodo.zurco.com.mx/nodo/api/v2";

    public function __construct($data)
    {
        $this->data = $data;
    }

    //FUNCION PARA GENERAR EL TOKEN Y PODER HACER CONSUMO DE LOS SERVICIOS
    public function generarToken()
    {
        // abrimos la sesiÃ³n cURL
        $ch = curl_init();

        // definimos la URL a la que hacemos la peticion
        //Token
        //dev
        //curl_setopt($ch, CURLOPT_URL, "http://localhost:3000/notarios/api/token");
        //prod
        curl_setopt($ch, CURLOPT_URL, $this->url."/token");

        // indicamos el tipo de peticiÃ³n: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parametros
        $data = array(
            'USUARIO'=>'aguas',
            'PASSWORD' => '123456',

        );
        $payload = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

        // definimos el tipo de header a usar
        $apikey = '63bc29ee6a8e9fhNd1d2407d0ac0';
        //dd($apikey);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json', 'x-api-key:'.$apikey
        ));



        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        // comprobamos el estatus de la peticion

        switch ($http_code) {
            case 200:  # OK

                $respuestaArray = json_decode($remote_server_output);
                $token = $this->busquedaToken($respuestaArray);

                break;

            case 400:
                $token = null;
                break;

            case 401:
                $token = null;
                break;

            case 403:
                $token = null;
                break;

            case 404:
                $token = null;
                break;

            case 500:
                $token = null;
                break;

            case 502:
                $token = null;
                break;

            case 503:
                $token = null;
                break;

            case 504:
                $token = null;
                break;

            default:
                $token = null;
        }

        // cerramos la peticion cURL
        curl_close($ch);

        return $token;
    }

    // FUNCION PARA ENVIAR LA LINEA DE CAPTURA NODO
    public function enviarLineaCapturaNodo($data)
    {
        $token = $this->generarToken();
        // abrimos la sesiÃ³n cURL
        $ch = curl_init();
        //dev
        //curl_setopt($ch, CURLOPT_URL, "http://localhost:3000/lineacaptura");
        //prod
        curl_setopt($ch, CURLOPT_URL, $this->url."/lineacaptura");

        // indicamos el tipo de peticiÃ³n: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parametros
        $payload = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

        // definimos el tipo de header a usar
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json', 'x-token:'.$token
        ));

        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        $respuestaArray = json_decode($remote_server_output);

        $estatus = false;

        foreach ($respuestaArray as $key => $val) {
            Log::info('Respuesta  respuestaArray de nodo: ');
            Log::info($key . ':  '.$val);
            if ($key === 'ok') {
                $estatus = $val;
            }
        }

        curl_close($ch);
        return $estatus;
    }

    public function busquedaToken($jsonRespuesta)
    {
        $token = null;

        foreach ($jsonRespuesta as $key => $val) {
            if ($key == 'token') {
                $token = $val;
            }
        }

        return $token;
    }

    public function enviarTramiteCorreccionNodo($data)
    {
        $token = $this->generarToken();
        // abrimos la sesionn cURL
        $ch = curl_init();
        //dev
        //curl_setopt($ch, CURLOPT_URL, "http://localhost:3000/correccion");
        //prod
        curl_setopt($ch, CURLOPT_URL, $this->url."/correccion");

        // indicamos el tipo de peticiÃ³n: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parametros
        $payload = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

        // definimos el tipo de header a usar
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json', 'x-token:'.$token
        ));



        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        $respuestaArray = json_decode($remote_server_output);

        $estatus = false;

        foreach ($respuestaArray as $key => $val) {
            Log::info('Respuesta  respuestaArray de nodo: ');
            Log::info($key . ':  '.$val);
            if ($key === 'ok') {
                $estatus = $val;
            }
        }

        return $estatus;
    }

    public function enviarTramiteTerminadoNodo($data)
    {
        $token = $this->generarToken();
        // abrimos la sesion cURL
        $ch = curl_init();
        //dev
        //curl_setopt($ch, CURLOPT_URL, "http://localhost:3000/documentaciontramite");
        //prod
        curl_setopt($ch, CURLOPT_URL, $this->url."/documentaciontramite");

        // indicamos el tipo de peticion: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parametros
        $payload = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

        // definimos el tipo de header a usar
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json', 'x-token:'.$token
        ));



        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        $respuestaArray = json_decode($remote_server_output);

        $estatus = false;

        foreach ($respuestaArray as $key => $val) {
            Log::info('Respuesta  respuestaArray de nodo: ');
            Log::info($key . ':  '.$val);
            if ($key === 'ok') {
                $estatus = $val;
            }
        }

        curl_close($ch);
        return $estatus;
    }

    public function enviarTramiteCanceladoNodo($data)
    {
        $token = $this->generarToken();
        // abrimos la sesion cURL
        $ch = curl_init();
        //dev
        //curl_setopt($ch, CURLOPT_URL, "http://localhost:3000/cancelartramite");
        //prod
        curl_setopt($ch, CURLOPT_URL, $this->url."/cancelartramite");
        // indicamos el tipo de peticion: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parametros
        $payload = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
        //dd($payload);
        // definimos el tipo de header a usar
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json', 'x-token:'.$token
        ));

        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        $respuestaArray = json_decode($remote_server_output);

        $estatus = false;

        foreach ($respuestaArray as $key => $val) {
            Log::info('Respuesta  respuestaArray de nodo: ');
            Log::info($key . ':  '.$val);
            if ($key === 'ok') {
                $estatus = $val;
            }
        }

        curl_close($ch);
        return $estatus;
    }
}