<?php


namespace App\Http\Controllers\Aguas;

use App\Model\Ventanilla\Tramite\Aguas;
use Illuminate\Support\Facades\Log;

class ConexionSei
{
    public function generaxml($tramite)
    {
        $xml = new \DOMDocument('1.0', 'UTF-8');
        if ($tramite->IDTIPOPERSONA != 2) {
            $apPaterno =$tramite->APELLIDOPATERNO;
            $apMaterno =$tramite->APELLIDOMATERNO;
        } else {
            $apPaterno ='--';
            $apMaterno ='--';
        }
        $conceptoPlantilla = "PAGO DE SERVICIOS DE AGUA POTABLE";

        $documento = $xml->createElement('documento');
        $documento = $xml->appendChild($documento);

        //PROD
        $documento->setAttribute('version', '3.1');
        $documento->setAttribute('tipo', 'ReporteAguas_V3.1');

        //DEV
        //$documento->setAttribute('tipo', 'ReporteCedula_V1.6');
        //$documento->setAttribute('version', '1.6');

        $documento->setAttribute('emisor', 'gypst');

        $cuerpo = $xml->createElement('cuerpo');
        $cuerpo = $documento->appendChild($cuerpo);

        $folioexterno = $xml->createElement('folio', $tramite->FOLIONODO);
        $folioexterno = $cuerpo->appendChild($folioexterno);
        $fechaactual = $xml->createElement('fecha', $this->fechaActual());
        $fechaactual = $cuerpo->appendChild($fechaactual);
        $notario = $xml->createElement('notario', $tramite->NOMBRESUSCRITO." ".$tramite->APELLIDOPATERNOSUSCRITO." ".$tramite->APELLIDOMATERNOSUSCRITO);
        $notario = $cuerpo->appendChild($notario);
        $catastro = $xml->createElement('catastro', $tramite->CATASTROCLAVEAGUA);
        $catastro = $cuerpo->appendChild($catastro);
        $nombre = $xml->createElement('nombre', $tramite->NOMBRE);
        $nombre = $cuerpo->appendChild($nombre);
        $paterno = $xml->createElement('paterno', $apPaterno);
        $paterno = $cuerpo->appendChild($paterno);
        $materno = $xml->createElement('materno', $apMaterno);
        $materno = $cuerpo->appendChild($materno);
        $calle = $xml->createElement('calle', $tramite->CALLE);
        $calle = $cuerpo->appendChild($calle);
        $exterior = $xml->createElement('exterior', $tramite->NUMEROEXTERIOR);
        $exterior = $cuerpo->appendChild($exterior);

        $interior = $xml->createElement('interior', $tramite->NUMEROINTERIOR);
        $interior = $cuerpo->appendChild($interior);

        $frac = $xml->createElement('fraccionamiento', $tramite->FRACCIONAMIENTO);
        $frac = $cuerpo->appendChild($frac);

        $colonia = $xml->createElement('colonia', $tramite->COLONIA);
        $colonia = $cuerpo->appendChild($colonia);

        $localidad = $xml->createElement('localidad', $tramite->LOCALIDAD);
        $localidad = $cuerpo->appendChild($localidad);

        $municipio = $xml->createElement('municipio', " ");
        $municipio = $cuerpo->appendChild($municipio);

        $concepto = $xml->createElement('concepto', $conceptoPlantilla);
        $concepto = $cuerpo->appendChild($concepto);

        $bimestre = $xml->createElement('bimestre', "BIMESTRE ".$tramite->BIMESTRE);
        $bimestre = $cuerpo->appendChild($bimestre);

        $aniobimestre = $xml->createElement('aniobimestre', $tramite->ANIOBIMESTRE);
        $aniobimestre = $cuerpo->appendChild($aniobimestre);

        $recibo = $xml->createElement('recibo', $tramite->RECIBOOFICIAL);
        $recibo = $cuerpo->appendChild($recibo);

        $fecha1 = explode(" ", $tramite->FECHARECIBO);
        $aniorecibo = $xml->createElement('aniorecibo', $fecha1[0]);
        $aniorecibo = $cuerpo->appendChild($aniorecibo);

        $derechos = $xml->createElement('derechos', $tramite->PAGODERECHOS);
        $derechos = $cuerpo->appendChild($derechos);

        $fecha2 = explode(" ", $tramite->FECHADERECHO);
        $anioderechos = $xml->createElement('anioderechos', $fecha2[0]);
        $anioderechos = $cuerpo->appendChild($anioderechos);
        $firmante = $xml->createElement('firmante', $tramite->NOMBRENOTARIO);
        $firmante = $cuerpo->appendChild($firmante);


        $remitentes = $xml->createElement('remitentes');
        $remitentes = $cuerpo->appendChild($remitentes);

        $remitente = $xml->createElement('remitente');
        $remitente = $remitentes->appendChild($remitente);
        //cuts
        $cuts = $xml->createElement('cuts','ROMO981020HMCMRL05');
        $cuts = $remitente->appendChild($cuts);

        $nombre = $xml->createElement('nombre', 'VICTOR MANUEL BAEZ MELO');
        $nombre = $remitente->appendChild($nombre);



        $xml->formatOutput = true;
        $el_xml = $xml->saveXML();

        //DEV
        //$xml->save('./application/libraries/jasper/ReporteCedula_V1.6.xml');
        //$xml->save('./assets/template/img/ReporteCedula_V1.6.xml');
        $xml->save('assets/media/files/ReporteAguas_V3.1.xml');

        //PROD
        //$xml->save('assets/media/files/ReporteAguas_V2.1.xml');
    }
    public function fechaActual()
    {
        $mes = date('m');
        if ($mes == 1) {
            $mesFormat = 'Enero';
        } elseif ($mes == 2) {
            $mesFormat = 'Febrero';
        } elseif ($mes == 3) {
            $mesFormat = 'Marzo';
        } elseif ($mes == 4) {
            $mesFormat = 'Abril';
        } elseif ($mes == 5) {
            $mesFormat = 'Mayo';
        } elseif ($mes == 6) {
            $mesFormat = 'Junio';
        } elseif ($mes == 7) {
            $mesFormat = 'Julio';
        } elseif ($mes == 8) {
            $mesFormat = 'Agosto';
        } elseif ($mes == 9) {
            $mesFormat = 'Septiembre';
        } elseif ($mes == 10) {
            $mesFormat = 'Octubre';
        } elseif ($mes == 11) {
            $mesFormat = 'Noviembre';
        } elseif ($mes == 12) {
            $mesFormat = 'Diciembre';
        }
        return (date('d'). ' de '.$mesFormat. ' de ' .date('Y'));
    }

    public function hash($tramite)
    {
        $this->generaxml($tramite);
        $xmlStr = file_get_contents('assets/media/files/ReporteAguas_V3.1.xml', true);

        $documento =  array("nombre"=>"firmas.pdf","contenido"=>$xmlStr);
        // print_r($documento);

        // DEV
        $firmante = array("ROMO981020HMCMRL05",'Con$D981020');
        // PROD
        //$firmante = array("BAMV811217HDFZLC01",'S4H$A&PUJ6');
        // print_r($firmante);

        $hash = null;

        //LLenamos la solicitud que enviaremos al metodo
        $solicitud = array( "solicitud"=>array(
            // "documento"=>$byte_array->BASE64,
            "documento"=>$documento,
            "listaFirmantes"=>array($firmante),
            "listaOrdenada"=>"false",
            "tipoDocumento"=>"1",
            "asunto" => "Prueba firma"
        )
        );
        $soapParams = array('login' => 'HuixTPAT', //Usuario proporcionado
            'password' => '0000', //Password proporcionado
            'cache_wsdl' => WSDL_CACHE_NONE,
            'authentication' => SOAP_AUTHENTICATION_BASIC, //Se realiza conexión
            'trace' => 1, //Parametro default
            'exceptions' => 0 //Parametro default
        );
        $wsdl = "http://qasistemas2.edomex.gob.mx/ceroPapel/webService?wsdl";

        $clientHash = new \SoapClient($wsdl, $soapParams);
        $responseHash = $clientHash->__soapCall("nuevaSolicitudBatch", array($solicitud));

        $hash= $responseHash->return;

        //dd($hash);
        return $hash;
    }
    public function conexionSEI($data)
    {

        // abrimos la sesiÃ³n cURL
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://zurco.com.mx:8081/generarurl");
        //https://zurco.com.mx:8081/generarurl

        // indicamos el tipo de peticion: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parametros
        $payload = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

        // definimos el tipo de header a usar
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json'
        ));

        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        $respuestaArray = json_decode($remote_server_output);
        curl_close($ch);
        $url = null;
        foreach ($respuestaArray as $key => $val) {
            if ($key === 'url') {
                $url = $val;
            }
        }
        //dd($url);
        if ($url) {
            return $url;
        } else {
            return false;
        }
    }
    
    public function conexionSEIQA($data)
    {
        $ch = curl_init();

        // definimos la URL a la que hacemos la petición
        // DEV
        //curl_setopt($ch, CURLOPT_URL, "http://35.236.47.61:8080/generarurl");
        curl_setopt($ch, CURLOPT_URL, "http://162.214.73.31:8081/generarurl");

        // PROD
        //curl_setopt($ch, CURLOPT_URL, "http://35.188.62.145:8080/generarurl");
        // indicamos el tipo de petición: POST
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        // definimos cada uno de los parámetros

        $payload = json_encode($data, JSON_UNESCAPED_SLASHES);

        curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

        // definimos el tipo de header a usar
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

        // recibimos la respuesta y la guardamos en una variable
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $remote_server_output = curl_exec($ch);


        // obtenemos el codigo la respuesta
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        // comprobamos el estatus de la peticion

        switch ($http_code) {
            case 200:  # OK

                $respuestaArray = json_decode($remote_server_output);

                $url = $this->busquedaURL($respuestaArray);


                if (strlen($url) >0) {
                    ///$estatus = true;
                    $response = array(
                        'estatus' => true,
                        'codigoHttp' => $http_code,
                        'url' => $url
                    );
                } else {
                    $response = array(
                        'estatus' => false,
                        'codigoHttp' => $http_code,
                        'url' => null
                    );
                }

                break;

            case 400:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 401:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 403:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 404:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 500:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 502:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 503:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            case 504:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
                break;

            default:
                $response = array(
                    'estatus' => false,
                    'codigoHttp' => $http_code,
                    'url' => null
                );
        }

        // cerramos la sesión cURL
        curl_close($ch);


        return $response['url'];
    }

    public function busquedaURL($jsonRespuesta)
    {
        $url = null;

        foreach ($jsonRespuesta as $key => $val) {
            Log::info('busquedaURL de sei: ');
            Log::info($key . ':  '.$val);
            if ($key == 'url') {
                $url = $val;
            }
        }

        return $url;
    }
}
