<?php


namespace App\Http\Controllers\Aguas;

use App\Http\Controllers\Controller;
use App\Model\Ventanilla\Catalogo\Zona;
use App\Model\Ventanilla\Tramite\Aguas;
use App\Model\Ventanilla\Catalogo\Estatus;
use Illuminate\Http\Request;

class GraficaController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    public function index()
    {
        return view('aguas/grafica');
    }

    public function verGrafica(Request $request)
    {
        $inicio = $request->input('fechaInicio');
        $fin = $request->input('fechaFin');

        $estatus = Estatus::pluck('IDESTATUSTRAMITE');
        $zona = Zona::pluck('IDZONA');

        $conteoEstatus = array();
        $conteoZona = array();

        foreach ($zona as $z) {
            $item = Aguas::where('IDZONA', '=', $z);
            if ($inicio != '') {
                $item = $item->where('FECHAACTUALIZACION', '>=', $inicio);
            }
            if ($fin != '') {
                $item = $item->where('FECHAACTUALIZACION', '<=', $fin);
            }
            $item = $item->where('VENTANILLA', '=', '0')->count();
            array_push($conteoZona, $item);
        }

        foreach ($estatus as $e) {
            $item = Aguas::where('IDESTATUS', '=', $e);
            if ($inicio != '') {
                $item = $item->where('FECHAACTUALIZACION', '>=', $inicio);
            }
            if ($fin != '') {
                $item = $item->where('FECHAACTUALIZACION', '<=', $fin);
            }
            $item = $item->where('VENTANILLA', '=', '0')->count();
            array_push($conteoEstatus, $item);
        }

        $response = array(
            'zona' =>$conteoZona,
            'estatus' => $conteoEstatus,
            'response' => 'true'
        );
        return $response;
    }
}
