<?php

namespace App\Http\Controllers\Api;

use App\Traits\ApiResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use App\Http\Requests\TokenRequest;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;

class TokenController extends Controller
{
    use ApiResponse;

    public function token(TokenRequest $request)
    {
        Log::info('Peticion de token');
        try {
            $header = $request->header('x-api-key');

            if ($header ===  'fxih0ee6a8e9fhNPd1d2407d0') {
                $credentials = $request->only(['email', 'password']);
                if (!Auth::attempt($credentials)) {
                    return $this->showError('No autorizado', [], 401);
                }

                $user = $request->user();
                Log::info('Usuario peticion token: '. $user);
                $tokenResult = $user->createToken('Personal Access Token');
                $token = $tokenResult->token;

                return $this->showOne([
                'ok'=> true,
                "status"=> 200,
                'message'=>'Success',
                'access_token' => $tokenResult->accessToken,
            ]);
            } else {
                return $this->showError('Invalid API_KEY', [], 401);
            }
        } catch (\Exception $exception) {
            return $this->showError('error', [
                $exception->getMessage()
            ], 401);
        }
    }
}
