<?php

namespace App\Http\Controllers;

use Barryvdh\DomPDF\Facade as PDF;
use Carbon\Carbon;
use App\Traits\ApiResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;
use App\Http\Controllers\Aguas\ConexionNodo;
use App\Model\Ventanilla\Tramite\Aguas;
use App\Model\Ventanilla\Catalogo\Estatus;
use App\Model\Ventanilla\Tramite\Documento;
use App\Model\Ventanilla\Catalogo\CatDocumento;

class TestController extends Controller
{
    use ApiResponse;

    public function generarCertificado($idTramite)
    {
        try {
            $firmaSei = $resultado = $responseNodo= null;
            //$idTramite = 501;
            $tramite = Aguas::find($idTramite);
            //dd($tramite);
            if ($tramite) {
                //Generammos xml
                $xml = $this->generaxml($tramite);
                //Obtenemos firma
                $firmaArray = $this->firmaSei($tramite);
                foreach ($firmaArray as $key => $val) {
                    //dd($key);
                    if ($key === 'resultado') {
                        $resultado = $val;
                        if ($resultado != '' && $resultado != null) {
                            $this->qrQenerate($resultado->cadenaQr);
                            $firmaSei = base64_encode(preg_replace('/\s+/', "", $resultado->firmaSei));
                            //dd($resultado);
                        }
                    }
                }
                //Generacion de certificado pdf - almacenar
                //ruta del qr - 'assets/media/files/Aguasqr.png'
                $tramites['firmaSei'] = $firmaSei;
                $tramites['datos'] = json_decode($tramite, false);
                $pdf = PDF::loadView('pdf/certificado', $tramites);
                //alamcenar pdf
                $pdf->save('assets/media/files/certificado.pdf');
                //return $this->showSuccess(json_decode($tramite, true));
                //Leer y subir a firebase
                //$file = file_get_contents('assets/media/files/test_pdf.pdf', true);//documento de prueba
                $file = file_get_contents('assets/media/files/certificado.pdf', true);//documento real
                $path = 'aguas/files/'.$tramite->IDTRAMITE.'/certificado.pdf';
                app('firebase.storage')->getBucket()->upload($file, ['name' => $path]);
                //unlink('assets/media/files/certificado.pdf');
                //unlink('assets/media/files/test_pdf.pdf');
                $pathReference = app('firebase.storage')->getBucket()->object($path);
                if ($pathReference->exists()) {
                    $path = $pathReference->signedUrl(Carbon::now()->addDays(7));
                    //dd($path);
                    return $this->showSuccess($path);
                //$responseNodo = $this->sendNodo($tramite, $path);
                } else {
                    dd('56');
                }
                //dd($resultado);
                //unlink('assets/media/files/Aguas.xml');
                //unlink('assets/media/files/Aguasqr.png');
                //return $this->showSuccessWeb('info', 'Peticion exitosa - firmado');
                if ($responseNodo) {
                    return $this->showSuccess($tramite->FOLIONODO);
                } else {
                    return $this->showErrorWeb('error', ['Error al mandar a nodo'], 500);
                }
            } else {
                return $this->showErrorWeb('error', ['Tramite no existente'], 404);
            }
        } catch (\Exception $exception) {
            if (file_exists('assets/media/files/certificado.pdf')) {
                unlink('assets/media/files/certificado.pdf');
            }
            if (file_exists('assets/media/files/Aguasqr.png')) {
                unlink('assets/media/files/Aguasqr.png');
            }
            if (file_exists('assets/media/files/Aguasqr.png')) {
                unlink('assets/media/files/Aguasqr.png');
            }
            Log::error($exception->getMessage());
            return $this->showError('error', [
                 $exception->getMessage()
             ], 500);
        }
    }

    public function generaxml($tramite)
    {
        try {
            $xml = new \DOMDocument('1.0', 'UTF-8');
            if ($tramite->IDTIPOPERSONA != 2) {
                $apPaterno =$tramite->APELLIDOPATERNO;
                $apMaterno =$tramite->APELLIDOMATERNO;
            } else {
                $apPaterno ='--';
                $apMaterno ='--';
            }
            $conceptoPlantilla = "PAGO DE SERVICIOS DE AGUA POTABLE";

            $documento = $xml->createElement('documento');
            $documento = $xml->appendChild($documento);

            //PROD
            $documento->setAttribute('version', '3.1');
            $documento->setAttribute('tipo', 'ReporteAguas_V3.1');

            $documento->setAttribute('emisor', 'gypst');

            $cuerpo = $xml->createElement('cuerpo');
            $cuerpo = $documento->appendChild($cuerpo);

            $folioexterno = $xml->createElement('folio', $tramite->FOLIONODO);
            $folioexterno = $cuerpo->appendChild($folioexterno);
            $fechaactual = $xml->createElement('fecha', Carbon::now()->format('Y-m-d'));
            $fechaactual = $cuerpo->appendChild($fechaactual);
            $notario = $xml->createElement('notario', $tramite->NOMBRESUSCRITO." ".$tramite->APELLIDOPATERNOSUSCRITO." ".$tramite->APELLIDOMATERNOSUSCRITO);
            $notario = $cuerpo->appendChild($notario);
            $catastro = $xml->createElement('catastro', $tramite->CATASTROCLAVEAGUA);
            $catastro = $cuerpo->appendChild($catastro);
            $nombre = $xml->createElement('nombre', $tramite->NOMBRE);
            $nombre = $cuerpo->appendChild($nombre);
            $paterno = $xml->createElement('paterno', $apPaterno);
            $paterno = $cuerpo->appendChild($paterno);
            $materno = $xml->createElement('materno', $apMaterno);
            $materno = $cuerpo->appendChild($materno);
            $calle = $xml->createElement('calle', $tramite->CALLE);
            $calle = $cuerpo->appendChild($calle);
            $exterior = $xml->createElement('exterior', $tramite->NUMEROEXTERIOR);
            $exterior = $cuerpo->appendChild($exterior);

            $interior = $xml->createElement('interior', $tramite->NUMEROINTERIOR);
            $interior = $cuerpo->appendChild($interior);

            $frac = $xml->createElement('fraccionamiento', $tramite->FRACCIONAMIENTO);
            $frac = $cuerpo->appendChild($frac);

            $colonia = $xml->createElement('colonia', $tramite->COLONIA);
            $colonia = $cuerpo->appendChild($colonia);

            $localidad = $xml->createElement('localidad', $tramite->LOCALIDAD);
            $localidad = $cuerpo->appendChild($localidad);

            $municipio = $xml->createElement('municipio', " ");
            $municipio = $cuerpo->appendChild($municipio);

            $concepto = $xml->createElement('concepto', $conceptoPlantilla);
            $concepto = $cuerpo->appendChild($concepto);

            $bimestre = $xml->createElement('bimestre', "BIMESTRE ".$tramite->BIMESTRE);
            $bimestre = $cuerpo->appendChild($bimestre);

            $aniobimestre = $xml->createElement('aniobimestre', $tramite->ANIOBIMESTRE);
            $aniobimestre = $cuerpo->appendChild($aniobimestre);

            $recibo = $xml->createElement('recibo', $tramite->RECIBOOFICIAL);
            $recibo = $cuerpo->appendChild($recibo);

            $fecha1 = explode(" ", $tramite->FECHARECIBO);
            $aniorecibo = $xml->createElement('aniorecibo', $fecha1[0]);
            $aniorecibo = $cuerpo->appendChild($aniorecibo);

            $derechos = $xml->createElement('derechos', $tramite->PAGODERECHOS);
            $derechos = $cuerpo->appendChild($derechos);

            $fecha2 = explode(" ", $tramite->FECHADERECHO);
            $anioderechos = $xml->createElement('anioderechos', $fecha2[0]);
            $anioderechos = $cuerpo->appendChild($anioderechos);
            $firmante = $xml->createElement('firmante', $tramite->NOMBRENOTARIO);
            $firmante = $cuerpo->appendChild($firmante);


            $remitentes = $xml->createElement('remitentes');
            $remitentes = $cuerpo->appendChild($remitentes);

            $remitente = $xml->createElement('remitente');
            $remitente = $remitentes->appendChild($remitente);
            //cuts
            $cuts = $xml->createElement('cuts', 'ROMO981020HMCMRL05');
            $cuts = $remitente->appendChild($cuts);

            $nombre = $xml->createElement('nombre', 'VICTOR MANUEL BAEZ MELO');
            $nombre = $remitente->appendChild($nombre);



            $xml->formatOutput = true;
            $el_xml = $xml->saveXML();

            //DEV
            //$xml->save('./application/libraries/jasper/ReporteCedula_V1.6.xml');
            //$xml->save('./assets/template/img/ReporteCedula_V1.6.xml');
            $xml->save('assets/media/files/Aguas.xml');
            return $this->showSuccessWeb('info', 'XML - creado correctamente');
        } catch (\Exception $exception) {
            Log::error($exception->getMessage());
            return $this->showError('error', [
                $exception->getMessage()
            ], 500);
        }
    }

    public function token()
    {
        try {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, "https://zurco.com.mx:8085/validador/api/token");
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $payload = json_encode(array(
                'pass'=>'overWP8.1',
                'email'=>'ricoocir970630@gmail.com'
            ));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json'
            ));
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            $remote_server_output = curl_exec($ch);
            $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            $respuestaArray = json_decode($remote_server_output);
            curl_close($ch);
            $token = $this->busquedaToken($respuestaArray);
            //dd($token);
            return $token;
        } catch (\Exception $exception) {
            Log::error($exception->getMessage());
            return $this->showError('error', [
                $exception->getMessage()
            ], 500);
        }
    }

    public function busquedaToken($respuestaArray)
    {
        $token = null;
        foreach ($respuestaArray as $key => $val) {
            if ($key == 'token') {
                $token = $val;
                if ($token != '') {
                    $token = $val;
                }
            }
        }
        return $token;
    }

    public function firmaSei($tramite)
    {
        $token = $this->token();
        $solicitante =json_encode(array(
            'nombre'=>$tramite->NOMBRE,
            'apellidoPaterno'=>$tramite->APELLIDOPATERNO,
            'apellidoMaterno'=>$tramite->APELLIDOMATERNO,
        ));
        $xmlStr = new \CURLFILE('assets/media/files/Aguas.xml', 'aplication/xml', 'Aguas.xml');
        //dd($xmlStr);
        $data = array(
            'solicitante'=> $solicitante,
            'folio'=> $tramite->FOLIONODO,
            'departamento'=>'AGUAS',
            'externo'=>true,
            'tipoTramite'=>'CNA',
            'archivo'=> $xmlStr,
            'fechaVencimiento'=>'12-12-2032',
            'rfc'=>'xxxxxxxxxxxxx',
        );
        $url = 'https://zurco.com.mx:8085/validador/generacion/qr';
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HTTPHEADER, [
            'Content-Type: multipart/form-data',
            'Authorization: '.$token
        ]);
        $response_json = curl_exec($curl);
        $error = curl_error($curl);
        if ($error) {
            return $error;
        } else {
            $respuestaArray = json_decode($response_json);
            //dd($respuestaArray);
            return $respuestaArray;
        }
    }

    public function qrQenerate($cadenaQr)
    {
        try {
            \QrCode::format('png')->size(700)->color(44, 40, 39)->generate($cadenaQr, 'assets/media/files/Aguasqr.png');
            return $this->showSuccessWeb('info', 'QR - creado correctamente');
        } catch (\Exception $exception) {
            Log::error($exception->getMessage());
            return $this->showError('error', [
            $exception->getMessage()
        ], 500);
        }
    }

    public function sendNodo($tramite, $path)
    {
        $data = array(
            'urlfirebase' => $path,
            'folio' => $tramite->FOLIONODO,
            'url'=>$path,
        );
        //Envio de certificado nodo - tramite terminado
        $conexion = new ConexionNodo($data);
        $respuesta = $conexion->enviarTramiteTerminadoNodo($data);
        if ($respuesta) {
            $tipoDocumento = CatDocumento::where('DESCRIPCION', 'like', 'CERTIFICADO FIRMADO')->pluck('IDDOCUMENTO');
            $documento = new Documento();
            $documento->NOMBREARCHIVO = 'certificado.pdf';
            $documento->CONTENTTYPE = 'application/pdf';
            $documento->PATH = $path;
            $documento->BASE64 = null;
            $documento->TIPODOCUMENTO = $tipoDocumento[0];
            $documento->FOLIOINTERNO = $tramite->FOLIONODO;
            $documento->save();
            $estatus = Estatus::where('DESCRIPCION', 'like', 'Certificado Emitido')->pluck('IDESTATUSTRAMITE');
            $tramite->IDESTATUS = $estatus[0];
            $tramite->FECHAACTUALIZACION = date('Y/m/d');
            $tramite->save();
            return true;
        } else {
            return $this->showErrorWeb('error', ['Error al mandar a nodo'], 500);
        }
    }
}
