<?php

namespace App\Http\Requests;

use App\Traits\ApiResponse;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class NotariosRequest extends FormRequest
{
    use ApiResponse;
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules(): array
    {
        return [
            'FOLIONODO' => 'required|string',
            'CATASTROCLAVEAGUA' => 'required|string',
            'CATASTRONUMERO' => 'required|string',
            'NOMBRE' => 'required|string',
            'APELLIDOPATERNO' => 'required|string',
            'APELLIDOMATERNO' => 'required|string',
            'NOMBRESUSCRITO' => 'required|string',
            'APELLIDOPATERNOSUSCRITO' => 'required|string',
            'APELLIDOMATERNOSUSCRITO' => 'required|string',
            'CALLE' => 'required|string',
            'NUMEROEXTERIOR' => 'required|string',
            'NUMEROINTERIOR' => 'required|string',
            'FRACCIONAMIENTO' => 'required|string',
            'COLONIA' => 'required|string',
            'LOCALIDAD' => 'required|string',
            'IDTIPOPERSONA' => 'required',
            'TELEFONO' => 'required|string',
            'NUMERONOTARIO' => 'required',
            'NOMBRENOTARIO' => 'required|string',
            'FOLIONOTARIOS' => 'required',
            'HASH' => 'required|string',
            'ZONADESCRIPCION' => 'required|string',
            'files' => 'required'
        ];
    }

    protected function failedValidation(Validator $validator)
    {
        throw new HttpResponseException($this->showError(
            'No se puede procesar la petición',
            $validator->errors()->all(),
            400
        ));
    }
}
