<?php


namespace App\Model\Ventanilla\Tramite;

use Illuminate\Database\Eloquent\Model;
use App\Model\Ventanilla\Catalogo\Estatus;
use App\Model\Ventanilla\Catalogo\Zona;

class Aguas extends Model
{
    protected $connection = 'aguas';
    protected $table = 'VENTANILLA_T_ADEUDO_AGUA';
    protected $primaryKey = 'IDTRAMITE';
    public $timestamps = false;
    protected $fillable = [
        'FOLIOAGUAS','NOMBRE','APELLIDOPATERNO','APELLIDOMATERNO','NOMBRESUSCRITO','APELLIDOPATERNOSUSCRITO','APELLIDOMATERNOSUSCRITO','CALLE','NUMEROEXTERIOR',
        'NUMEROINTERIOR','FRACCIONAMIENTO','COLONIA','LOCALIDAD','IDTIPOPERSONA','IDZONA','TELEFONO','NUMERONOTARIO','NOMBRENOTARIO','CATASTRONUMERO',
        'CATASTROCLAVEAGUA','FOLIONODO','IDESTATUS','FECHAINICIO','FECHAACTUALIZACION','FOLIONOTARIOS','HASH','VENTANILLA','BIMESTRE',
        'ANIOBIMESTRE','RECIBOOFICIAL','FECHARECIBO','PAGODERECHOS','FECHADERECHO'
    ];

    public function zona()
    {
        return $this->belongsTo(Zona::class, 'IDZONA', 'IDZONA');
    }

    public function estatus()
    {
        return $this->belongsTo(Estatus::class, 'IDESTATUS', 'IDESTATUSTRAMITE');
    }
}
