<?php

namespace App\Traits;

trait ApiResponse
{
    /**
     * Show one entity
     *
     * @param $resource
     * @param int $code
     */
    public function showOne($entity, int $code = 200)
    {
        return response()->json([
            'data' => $entity
        ], $code);
    }

    /**
     * Show one
     *
     * @param $resource
     * @param int $code
     */
    public function showSuccess($entity, int $code = 200)
    {
        return response()->json([
            'ok' => true,
            'status' => $code,
            'message' => 'Success',
            'folioExterno' => $entity
        ], $code);
    }

    /**
     * Show error
     *
     * @param string $message
     * @param array $errors
     * @param int $code
     */
    public function showError(string $message, array $errors, int $code)
    {
        return response()->json([
            'ok' => false,
            'message' => $message,
            'errors' => $errors
        ], $code);
    }
    public function showErrorWeb(string $message, array $error, int $code)
    {
        return response()->json([
            'ok' => false,
            'message' => $message,
            'error' => $error
        ], $code);
    }

    public function showSuccessWeb($param, $entity, int $code = 200)
    {
        return response()->json([
            'ok' => true,
            'status' => $code,
            'message' => 'Success',
            $param => $entity
        ], $code);
    }
}
