@extends('aguas.layouts.plantilla')

@section('contenido')
    <div class="kt-portlet kt-portlet--mobile">
        <div class="kt-portlet__head kt-portlet__head--lg">
            <div class="kt-portlet__head-label">
                <h3 class="kt-portlet__head-title">Certificado de no adeudo de aguas
                    <small>Gráficas informativas</small>
                </h3>
            </div>
        </div>

        <div class="kt-portlet__body text-dark" >
            <div class="col-lg-4">
                    <h5>Instrucciones:</h5>
                <p>1. Seleccione rango de fechas a buscar</p>
                <p>2. Dar click en buscar para mostrar el reporte en ese intervalo de fechas</p>
                    <div class="form-group ">
                        <label>Fecha Inicio</label><input type="date" class="form-control" id="inicio" name="inicio">
                        <label>Fecha Final</label><input type="date" class="form-control" id="fin" name="fin">
                        <button type="submit" class="btn btn-default btn-primary" onclick="mostrarGrafica()">Buscar</button>
                    </div>
            </div>
            <div class="col-lg-10">
                <div id="columnchart_values"></div>
            </div>
            <div class="col-lg-10">
                <div id="table_div"></div>
            </div>

            <div class="col-lg-10">
                <div id="columnchart_values_zonas"></div>
            </div>
            <div class="col-lg-10">
                <div id="table_div_zonas"></div>
            </div>
        </div>
    </div>

    <script type="text/javascript">
        function mostrarGrafica(){

            var url = '/verGrafica';

            var fechaInicio = $("#inicio").val();
            var fechaFin = $("#fin").val();

            $.ajax({
                type: "GET",
                url: url,
                dataType: 'json',
                data: {fechaInicio:fechaInicio,fechaFin:fechaFin},
                success:function(response){
                    //alert(response.estatus)

                    dibujarGrafica(response.estatus);
                    dibujarTabla(response.estatus);
                    dibujarGraficaZona(response.zona);
                    dibujarTablaZona(response.zona);
                }
            });

        }
        function dibujarGraficaZona(zona){
            google.charts.load('current', {'packages':['corechart']});
            google.charts.setOnLoadCallback(drawChart);
            function drawChart() {
                var popular = 1182*zona[0];
                var residencial = 3421*zona[1];
                var comercial = 4373*zona[2];
                var data = google.visualization.arrayToDataTable([
                    ["Zona", "Ingreso Total"],
                    ['Popular', popular],
                    ['Residencial', residencial],
                    ['Comercial', comercial]
                ]);

                var options = {
                    title: 'Ingreso de trámite por zona',
                    is3D: true,
                };
                var chart = new google.visualization.PieChart(document.getElementById("columnchart_values_zonas"));
                chart.draw(data, options);
            }
        }

        function dibujarGrafica(estatus){
            google.charts.load('current', {'packages':['corechart']});
            google.charts.setOnLoadCallback(drawChart);
            function drawChart() {
                var data = google.visualization.arrayToDataTable([
                    ["Estatus", "Cantidad"],
                    ['Solicitud Nueva', estatus[0]],
                    ['Solicitud Revisada', estatus[1]],
                    ['Linea de Pago Emitida', estatus[2]],
                    ['Tramite Pagado', estatus[3]],
                    ['Certificado Emitido', estatus[4]],
                    ['Ver Precedula', estatus[5]],
                    ['Tramite Cancelado', estatus[6]],
                    ['Generar Precedula', estatus[7]]
                ]);

                var options = {
                    title: 'Trámites realizados',
                    is3D: true,
                };
                var chart = new google.visualization.PieChart(document.getElementById("columnchart_values"));
                chart.draw(data, options);
            }
        }
    </script>
    <script type="text/javascript">
        function dibujarTabla(estatus) {
            google.charts.load('current', {'packages': ['table']});
            google.charts.setOnLoadCallback(drawTable);

            function drawTable() {
                var data = new google.visualization.DataTable();
                data.addColumn('string', 'Estatus');
                data.addColumn('number', 'Cantidad');
                data.addRows([
                    ['Solicitud Nueva', estatus[0]],
                    ['Solicitud Revisada', estatus[1]],
                    ['Linea de Pago Emitida', estatus[2]],
                    ['Tramite Pagado', estatus[3]],
                    ['Certificado Emitido', estatus[4]],
                    ['Ver Precedula', estatus[5]],
                    ['Tramite Cancelado', estatus[6]],
                    ['Generar Precedula', estatus[7]]
                ]);

                var table = new google.visualization.Table(document.getElementById('table_div'));

                table.draw(data, {showRowNumber: true, width: '60%', height: '60%'});
            }
        }

        function dibujarTablaZona(zona) {
            google.charts.load('current', {'packages': ['table']});
            google.charts.setOnLoadCallback(drawTable);

            function drawTable() {
                var data = new google.visualization.DataTable();
                var popular = 1182*zona[0];
                var residencial = 3421*zona[1];
                var comercial = 4373*zona[2];
                data.addColumn('string', 'Zona');
                data.addColumn('string', 'Total Ingresado');
                data.addRows([
                    ['Popular', new Intl.NumberFormat('es-MX', { style: 'currency', currency: 'MXN' }).format(popular)],
                    ['Residencial', new Intl.NumberFormat('es-MX', { style: 'currency', currency: 'MXN' }).format(residencial)],
                    ['Comercial', new Intl.NumberFormat('es-MX', { style: 'currency', currency: 'MXN' }).format(comercial)],
                    ['Total', new Intl.NumberFormat('es-MX', { style: 'currency', currency: 'MXN' }).format(popular+comercial+residencial)]
                ]);

                var table = new google.visualization.Table(document.getElementById('table_div_zonas'));

                table.draw(data, {showRowNumber: true, width: '60%', height: '60%'});
            }
        }
    </script>

@endsection