@extends('aguas.layouts.plantilla')

@section('contenido')
    <div class="kt-portlet kt-portlet--mobile">
        <div class="kt-portlet__head kt-portlet__head--lg">
            <div class="kt-portlet__head-label">
                <h3 class="kt-portlet__head-title">Certificado de no adeudo de aguas
                    <small>Trámites de ventanilla</small>
                </h3>
            </div>
            <div class="kt-portlet__head-toolbar">
                <div class="kt-portlet__head-wrapper">
                    <a href="#" class="btn btn-clean kt-hidden">
                        Back to dashboard
                    </a>
                    <a href="#" class="btn btn-clean btn-bold btn-upper btn-font-sm kt-hidden">
                        <i class="la la-long-arrow-left"></i>
                        Back
                    </a>
                    <button type="button" class="btn btn btn-outline-brand" data-toggle="modal"
                        data-target="#exampleModalLong">
                        <i class="flaticon2-add-1"></i>
                        New Record
                    </button>
                    &nbsp;
                </div>
            </div>
        </div>
        <div class="kt-portlet__body">

            <!--begin: Datatable -->
            <table class="table table-striped- table-bordered table-hover table-checkable" style="font-size:1.0em"
                id="kt_table_1">
                <thead>
                    <tr>
                        <th>Folio</th>
                        <th>Zona</th>
                        <th>Status</th>
                        <th>Acciones</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($tramite as $item)
                        <tr>
                            <td>{{ $item->FOLIOAGUAS }}</td>
                            <td>{{ $item->zona->DESCRIPCION }}</td>
                            <td>{{ $item->estatus->DESCRIPCION }}</td>
                            <td>
                                <button type="button" class="btn btn btn-outline-brand text-primary flaticon2-list-2"
                                    title="Informacion" onclick="show({{ $item->IDTRAMITE }})">
                                </button>
                                <button type="button" class="btn btn btn-outline-brand text-dark fa fa-file-pdf"
                                    title="Documentos" onclick="showDocumentos({{ $item->IDTRAMITE }})">
                                </button>
                                @if ($item->estatus->CLAVE == 'SN-CNA' && (\Illuminate\Support\Facades\Auth::user()->rol == 1 || \Illuminate\Support\Facades\Auth::user()->rol == 4))
                                    <button type="button"
                                        class="btn btn btn-outline-brand text-success flaticon2-check-mark"
                                        onclick="cambiarEstatus({{ $item->IDTRAMITE }})" title="Continuar">
                                    </button>
                                @endif
                                @if ($item->estatus->CLAVE == 'SR-CNA' && (\Illuminate\Support\Facades\Auth::user()->rol == 1 || \Illuminate\Support\Facades\Auth::user()->rol == 4))
                                    <button type="button" class="btn btn btn-outline-brand text-success flaticon2-writing"
                                        onclick="cambiarEstatus({{ $item->IDTRAMITE }})" title="Generar Linea">
                                    </button>
                                @endif
                                @if ($item->estatus->CLAVE == 'TP-CNA' && (\Illuminate\Support\Facades\Auth::user()->rol == 1 || \Illuminate\Support\Facades\Auth::user()->rol == 3))
                                    <button type="button" class="btn btn btn-outline-brand text-success fa fa-coins"
                                        onclick="Precedula({{ $item->IDTRAMITE }})" title="Aprobar Pago">
                                    </button>
                                @endif
                                @if ($item->estatus->CLAVE == 'VP-CNA' && (\Illuminate\Support\Facades\Auth::user()->rol == 1 || \Illuminate\Support\Facades\Auth::user()->rol == 2))
                                    <button type="button"
                                        class="btn btn btn-outline-brand text-success fa  fa-file-contract"
                                        onclick="cambiarEstatus({{ $item->IDTRAMITE }})" title="Generar Certificado">
                                    </button>
                                @endif
                                @if ($item->estatus->CLAVE == 'SN-CNA' || $item->estatus->CLAVE == 'SR-CNA')
                                    <button type="button" class="btn btn btn-outline-brand text-danger  flaticon2-delete"
                                        onclick="cancelarModal({{ $item->IDTRAMITE }})" title="Cancelar">
                                    </button>
                                @endif
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
            {{ $tramite->links() }}

            <!--end: Datatable -->
        </div>
        <div class="modal fade" id="exampleModalLong" tabindex="-1" role="dialog"
            aria-labelledby="exampleModalLongTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Registrar Tramite</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="kt-portlet__body">
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Nombre</label>
                                <div class="col-10">
                                    <input class="form-control" type="text" value="" id="nombrestore"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Apellido Paterno</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="paternostore"
                                        oninput="validarStore()">
                                </div>
                                <label for="example-text-input" class="col-2 col-form-label">Apellido Materno</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="maternostore"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Nombre suscrito</label>
                                <div class="col-10">
                                    <input class="form-control" type="text" value="" id="nombresuscrito"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Apellido Paterno
                                    Suscrito</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="paternosuscrito"
                                        oninput="validarStore()">
                                </div>
                                <label for="example-text-input" class="col-2 col-form-label">Apellido Materno
                                    Suscrito</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="maternosuscrito"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Calle</label>
                                <div class="col-10">
                                    <input class="form-control" type="text" value="" id="callestore"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">No Ext</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="externostore"
                                        oninput="validarStore()">
                                </div>
                                <label for="example-text-input" class="col-2 col-form-label">No Int</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="interiorstore"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Fraccionamiento</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="fraccionamiento"
                                        oninput="validarStore()">
                                </div>
                                <label for="example-text-input" class="col-2 col-form-label">Colonia</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="colonia"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Localidad</label>
                                <div class="col-8">
                                    <input class="form-control" type="text" value="" id="localidad"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Telefono</label>
                                <div class="col-8">
                                    <input class="form-control" type="text" value="" id="telefono"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="example-text-input" class="col-2 col-form-label">Numero Catastro</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="catastro"
                                        oninput="validarStore()">
                                </div>
                                <label for="example-text-input" class="col-2 col-form-label">Clave Agua</label>
                                <div class="col-4">
                                    <input class="form-control" type="text" value="" id="claveagua"
                                        oninput="validarStore()">
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="tipopersonas">Tipo Persona</label>
                                <select class="form-control" id="tipopersona">
                                    <option value="1">Fisica</option>
                                    <option value="2">Moral</option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="zonas">Zona</label>
                                <select class="form-control" id="zona">
                                    <option value="3">Tradicional</option>
                                    <option value="2">Residencial</option>
                                    <option value="1">Popular</option>
                                </select>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-brand" data-dismiss="modal">Close</button>
                        <button type="button" class="btn btn-primary" id="guardaTramite" onclick="store()"
                            disabled>Guardar</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="ModalInfo" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Información del Trámite</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form class="kt-form">
                            <div class="kt-portlet__body">
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Apellido Paterno</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoPaterno" disabled>
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">Apellido Materno</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoMaterno" disabled>
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Nombre</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoNombre" disabled>
                                    </div>

                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Calle</label>
                                    <div class="col-lg-10">
                                        <input class="form-control" type="text" value="" id="InfoCalle" disabled>
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">No. Exterior</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoExterior" disabled>
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">No. Interior</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoInterior" disabled>
                                    </div>
                                </div>

                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Coloniat</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoColonia" disabled>
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">Localidad</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoLocalidad" disabled>
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Número de Catastro</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoCatastro" disabled>
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">Catastro Agua</label>
                                    <div class="col-lg-4">
                                        <input class="form-control" type="text" value="" id="InfoAguas" disabled>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-brand" data-dismiss="modal">Cerrar</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="ModalDocs" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Lista de Documentos</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <table class="table" id="tbLstArchivos">
                            <thead>
                                <tr>
                                    <th scope="col">
                                        NOMBRE ARCHIVO
                                    </th>
                                    <th scope="col">
                                        Acción
                                    </th>
                                </tr>
                            </thead>
                            <tbody>

                            </tbody>
                        </table>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-brand" data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="Spinner" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-body">
                        <div
                            class="kt-spinner text-primary kt-spinner--v2 kt-spinner--right kt-spinner--sm kt-spinner--dark">
                            Cargando</div>&nbsp;
                    </div>
                </div>
            </div>
        </div>
        <div class="modal fade" id="showPDF" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Documento</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <div class="modal-body" id="modalDocumento">

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-brand" data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="ModalCancelar" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Cancelar</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form class="kt-form">
                            <div class="kt-portlet__body">
                                <div class="form-group row">
                                    <div class="col-lg-4">
                                        <label for="example-text-input" class="col-2 col-form-label">Motivo:</label>
                                        <input type="hidden" id="idCancelar">
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <div class="col-lg-12">
                                        <textarea class="form-control" type="text" value="" id="Motivo" onInput="validarInput()"> </textarea>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-brand bg-danger text-light btn-cancelar-enviar" id="CancelarForm"
                            onclick="Cancelar()" disabled>Cancelar</button>
                        <button type="button" class="btn btn-outline-brand" data-dismiss="modal">Cerrar</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="ModalPrecedula" tabindex="-1" role="dialog" aria-labelledby="exampleModalLongTitle"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-scrollable" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Datos de Recibo</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form class="kt-form">
                            <div class="kt-portlet__body">
                                <div class="form-group row">
                                    <div class="col-lg-4">
                                        <input type="hidden" id="idTramite">
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Bimestre:</label>
                                    <div class="col-lg-4">
                                        <input type="number" class="form-control" type="text" value="" id="bimestre"
                                            onInput="validarInputP()">
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">Año Bimestre:</label>
                                    <div class="col-lg-4">
                                        <input type="number" class="form-control" type="text" value="" id="aniobimetre"
                                            onInput="validarInputP()">
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Numero Recibo:</label>
                                    <div class="col-lg-4">
                                        <input type="text" class="form-control" type="text" value="" id="recibo"
                                            onInput="validarInputP()">
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">Fecha de Recibo:</label>
                                    <div class="col-lg-4">
                                        <input type="date" class="form-control" type="text" value="" id="fecharecibo"
                                            onInput="validarInputP()">
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="example-text-input" class="col-2 col-form-label">Número Pago de
                                        Derechos:</label>
                                    <div class="col-lg-4">
                                        <input type="text" class="form-control" type="text" value="" id="pagoderechos"
                                            onInput="validarInputP()">
                                    </div>
                                    <label for="example-text-input" class="col-2 col-form-label">Fecha de Recibo:</label>
                                    <div class="col-lg-4">
                                        <input type="date" class="form-control" type="text" value="" id="fechaderechos"
                                            onInput="validarInputP()">
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-outline-brand bg-success text-light" id="PrecedulaForm"
                            onclick="generaPrecedula()" disabled>Aceptar</button>
                        <button type="button" class="btn btn-outline-brand" data-dismiss="modal">Cerrar</button>
                    </div>
                </div>
            </div>
        </div>

    </div>
@endsection
<script type="text/javascript">
    function show(idTramite) {
        var url = '/verTramite';
        $("#Spinner").modal("show");

        $.ajax({
            type: "GET",
            url: url,
            dataType: 'json',
            data: {
                idTramite: idTramite
            },
            success: function(response) {
                $("#Spinner").modal("hide");
                $("#InfoPaterno").val(response.APELLIDOPATERNO);
                $("#InfoMaterno").val(response.APELLIDOMATERNO);
                $("#InfoNombre").val(response.NOMBRE);
                $("#InfoCalle").val(response.CALLE);
                $("#InfoExterior").val(response.NUMEROEXTERIOR);
                $("#InfoInterior").val(response.NUMEROINTERIOR);
                $("#InfoColonia").val(response.COLONIA);
                $("#InfoLocalidad").val(response.LOCALIDAD);
                $("#InfoCatastro").val(response.CATASTRONUMERO);
                $("#InfoAguas").val(response.CATASTROCLAVEAGUA);
                $("#ModalInfo").modal("show");
            }
        });

    }

    function store() {
        var url = '/storeVentanilla';
        $("#exampleModalLong").modal("hide");

        $("#Spinner").modal("show");

        var nombrestore = $("#nombrestore").val();
        var paternostore = $("#paternostore").val();
        //form_data.append('maternostore', $("#maternostore").val());
        /*form_data.append('nombresuscrito', $("#nombresuscrito").val());
        form_data.append('paternosuscrito', $("#paternosuscrito").val());
        form_data.append('maternosuscrito', $("#maternosuscrito").val());
        form_data.append('callestore', $("#callestore").val());
        form_data.append('externostore', $("#externostore").val());
        form_data.append('interiorstore', $("#interiorstore").val());
        form_data.append('fraccionamiento', $("#fraccionamiento").val());
        form_data.append('colonia', $("#colonia").val());
        form_data.append('localidad', $("#localidad").val());
        form_data.append('telefono', $("#telefono").val());
        form_data.append('catastro', $("#catastro").val());
        form_data.append('claveagua', $("#claveagua").val());
        form_data.append('tipopersona', $("#tipopersona").val());
        form_data.append('zona', $("#zona").val());*/

        //var form_data =

        $.ajax({
            type: "GET",
            url: url,
            dataType: 'json',
            data: {
                nombrestore: nombrestore
            },
            success: function(response) {
                $("#Spinner").modal("hide");
                swal.fire("Se registro tramite", "", "success");
                location.reload(true);
            }
        });

    }

    function showDocumentos(idTramite) {
        var url = '/verDocumentos';
        $("#Spinner").modal("show");
        $("object").remove();
        $("#DocumentosShow").empty();


        $.ajax({
            type: "GET",
            url: url,
            dataType: 'json',
            data: {
                idTramite: idTramite
            },
            success: function(response) {
                $("#Spinner").modal("hide");
                for (var i = 0; i < response.length; i++) {
                    $("#tbLstArchivos > tbody:last").append("<tr class='celdaDocumentos'> <td>" + response[
                            i].NOMBREARCHIVO +
                        " </td> <td><button type='button' class='btn btn-primary' onClick='showDoc(" +
                        response[i].IDDOCUMENTO + ")'> Abrir</button> </td>  </tr>");
                }
                $("#ModalDocs").modal("show");
            }
        });

    }

    function showDoc(idDocumento) {
        var url = '/verDocumento';
        $("object").remove();

        $("#Spinner").modal("show");


        $.ajax({
            type: "GET",
            url: url,
            dataType: 'json',
            data: {
                idDocumento: idDocumento
            },
            success: function(response) {
                $("#Spinner").modal("hide");
                $("#modalDocumento").append(
                    '<object class="DocumentosShow" data="data:application/pdf;base64,' + response
                    .BASE64 + '" width="100%" height="500px" type="application/pdf"></object>');
                $("#showPDF").modal("show");
            }
        });
    }

    function validarInput() {
        if ($("#Motivo").val() != "") {
            $("#CancelarForm").prop('disabled', false);
        } else {
            $("#CancelarForm").prop('disabled', true);
        }
    }

    function validarStore() {
        if ($("#nombrestore").val() != "" && $("#paternostore").val() != "" && $("#maternostore").val() != "" && $(
                "#nombresuscrito").val() != "" && $("#paternosuscrito").val() != "" && $("#maternosuscrito").val() !=
            "" &&
            $("#callestore").val() != "" && $("#externostore").val() != "" && $("#interiorstore").val() != "" && $(
                "#fraccionamiento").val() != "" && $("#colonia").val() != "" &&
            $("#localidad").val() != "" && $("#telefono").val() != "" && $("#catastro").val() != "" && $("#claveagua")
            .val() != "") {
            $("#guardaTramite").prop('disabled', false);
        } else {
            $("#guardaTramite").prop('disabled', true);
        }
    }

    function validarInputP() {
        if ($("#bimestre").val() != "" && $("#aniobimetre").val() != "" && $("#recibo").val() != "" && $("#fecharecibo")
            .val() != "" && $("#fechaderechos").val() != "" && $("#pagoderechos").val() != "") {
            $("#PrecedulaForm").prop('disabled', false);
        } else {
            $("#PrecedulaForm").prop('disabled', true);
        }
    }

    function Precedula(idTramite) {
        $("#idTramite").val(idTramite);
        $("#ModalPrecedula").modal("show");
    }

    function generaPrecedula() {
        var url = '/actualizarTramite';
        $("#ModalPrecedula").modal("hide");
        $("#Spinner").modal("show");
        var idTramite = $("#idTramite").val();
        var bimestre = $("#bimestre").val();
        var aniobimetre = $("#aniobimetre").val();
        var recibo = $("#recibo").val();
        var fecharecibo = $("#fecharecibo").val();
        var fechaderechos = $("#fechaderechos").val();
        var pagoderechos = $("#pagoderechos").val();

        $.ajax({
            type: "GET",
            url: url,
            dataType: 'json',
            data: {
                idTramite: idTramite,
                bimestre: bimestre,
                aniobimetre: aniobimetre,
                recibo: recibo,
                fecharecibo: fecharecibo,
                fechaderechos: fechaderechos,
                pagoderechos: pagoderechos
            },
            success: function(response) {
                $("#Spinner").modal("hide");
                swal.fire("Se actualizo tramite", "", "success");
                location.reload(true);
            }
        });
    }

    function cancelarModal(idTramite) {
        $("#idCancelar").val(idTramite);
        $("#ModalCancelar").modal("show");
    }

    function Cancelar() {
        var url = '/cancelarTramite';
        $("#ModalCancelar").modal("hide");
        $("#Spinner").modal("show");
        var motivo = $("#Motivo").val();
        var idtramite = $("#idCancelar").val();
        console.log(motivo);
        console.log(idtramite);
        $.ajax({
            type: "GET",
            url: url,
            dataType: 'json',
            data: {
                idtramite: idtramite,
                motivo: motivo
            },
            success: function(response) {
                $("#Spinner").modal("hide");
                swal.fire("Se actualizo tramite", "", "success");
                location.reload(true);
            },
            error: function(error) {
                console.log('error');
                console.log(error);
                $("#Spinner").modal("hide");
                swal.fire("Hubo un error, intente más tarde", "", "warning");
            }
        });
    }

    function cambiarEstatus(idTramite) {
        var url = '/actualizarTramite';

        setTimeout(() => {
            $.ajax({
                type: "GET",
                url: url,
                dataType: 'json',
                data: {
                    idTramite: idTramite
                },
                success: function(response) {
                    swal.fire("Se actualizo tramite", "", "success");
                    location.reload(true);
                },
                error: function(error) {
                    console.log('error');
                    console.log(error);
                    swal.fire("Hubo un error, intente más tarde", "", "warning");
                }
            });
        }, 4000);
    }
</script>
