@extends('layouts.masterlogaout')

@section('contenido')
<div class="container">
    <div class="row">
        <div class=" col-12 col-sm-12 col-md-6 col-lg-6">
            {{-- <img style="min-height: 50%; max-width:90vw;height:auto;" class="w-100" src="assets/media/portada2.png" alt="logo-portada"> --}}
            <div class="portada"></div>
        </div>
        <div class="col-12 col-sm-12 col-md-6 col-lg-6">
            <div class="card login">
                <div class="card-header head-login">{{ __('Introduce tus datos') }}</div>

                <div class="login-body">
                    <form style="margin:0 auto!important;" method="POST" action="{{ route('login') }}">
                        @csrf

                        <div class="form-group row">
                            <label for="email" class="text-left col-10 col-sm-10 col-md-10">
                                {{ __('Correo') }}
                            </label>
                            <div class="col-md-9">
                                <input id="email" type="email" class="form-control @error('email') is-invalid @enderror input-login" name="email" value="{{ old('email') }}" required autocomplete="false" autofocus />
                                @error('email')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="password" class="text-left col-md-9 ">{{ __('Contraseña') }}</label>
                            <div class="col-md-9">
                                <input id="password" type="password" class="form-control @error('password') is-invalid @enderror input-login" name="password" required autocomplete="current-password">
                                @error('password')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        
                        <div class="form-group row ">
                            <div class="col-md-4">
                                <div class="form-check float-center">
                                    <input class="form-check-input text-right" type="checkbox" name="remember" id="remember" {{ old('remember') ? 'checked' : '' }}>
                                    <label class="form-check-label" for="remember">
                                        {{ __('Recordarme') }}
                                    </label>
                                </div>
                            </div>
                            &nbsp; 
                            <div class="col-md-4">
                                @if (Route::has('password.request'))
                                    <a class="list-item" href="{{ route('password.request') }}">
                                        {{ __('Recupera tu contraseña') }}
                                    </a>
                                @endif
                            </div>
                            <div class="col-md-9 mt-6">
                                <button type="submit" class="btn btn-primary btn-lg  btn-login-form w-100">
                                    {{ __('Entrar') }}
                                </button>
                            </div>
                            <div class="col-md-9 mt-6">
                                <button type="reset" class="btn btn-default btn-lg  btn-login-form w-100">
                                    Limpiar datos
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection