<?php

use Illuminate\Http\Request;
use App\Http\Controllers\Api\NotariosApiController;
use App\Http\Controllers\Api\TokenController;
use App\Http\Controllers\Api\Test\TestController;
use App\Http\Controllers\Api\Auth\LogoutApiController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/
Route::group(['prefix' => 'v2/auth'], function () {
    Route::post('token', [TokenController::class, 'token'])->name('token');
});

Route::group(['prefix' => 'v2/logout', 'middleware' => 'auth:api'], function () {
    Route::post('revoke', [LogoutApiController::class, 'revoke']);
});

Route::group(['prefix' => 'v2/notarios', 'middleware' => 'auth:api'], function () {
    Route::post('agregar', [NotariosApiController::class, 'store']);
    Route::post('lineaPago', [NotariosApiController::class, 'lineaPago']);
    Route::post('correccion', [NotariosApiController::class, 'correccion']);
});
Route::group(['prefix' => 'v2/test', 'middleware' => 'api'], function () {
    Route::post('peticiontest', [TestController::class, 'peticiontest'])->name('peticiontest');
    Route::post('tokentest', [TestController::class, 'tokenTest'])->name('tokentest');
});
