<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/', 'IndexController@login')->name('login');
Route::get('/example', 'IndexController@welcome')->name('welcome');
Route::get('/tabla', 'IndexController@tabla')->name('tabla');
Route::get('/tablaguas', 'IndexController@tablaguas')->name('tablaguas');

Auth::routes();

//HOME
Route::get('/home', 'HomeController@index')->name('home');

//GRAFICAS
Route::get('/reportes', 'Aguas\GraficaController@index')->name('graficaHome');

Route::get('/verGrafica', 'Aguas\GraficaController@verGrafica');

//NOTARIOS AGUAS
Route::get('/notarios', 'Aguas\NotarioController@index')->name('notarioHome');
Route::get('/verTramite', 'Aguas\NotarioController@show');
Route::post('/cancelarTramite', 'Aguas\NotarioController@cancel');
Route::get('/actualizarTramite', 'Aguas\NotarioController@update');
Route::post('/lineaPago', 'Aguas\NotarioController@lineaPago');
Route::get('/verSolicitud', 'Aguas\NotarioController@verSolicitud');
Route::get('/verCancelacion', 'Aguas\NotarioController@verCancelacion');
Route::get('/verNotificaciones', 'Aguas\NotarioController@verNotificaciones');
Route::get('/buscarFolio', 'Aguas\NotarioController@buscarFolio');
//Correccion
Route::post('/correccion', 'Aguas\NotarioController@correccion');
//Documentos AGUAS
Route::get('/verDocumentos', 'Aguas\DocumentoController@index');
Route::get('/verDocumento', 'Aguas\DocumentoController@show');
//Generar certificado
Route::post('/generarCertificado/{idTramite}', 'Aguas\FirmaControler@generarCertificado')->name('generarCertificado');
//Generar precedula
Route::post('/generaPrecedula/{idTramite}', 'ArchivosController@generaPrecedula')->name('generaPrecedula');
//Generar linea
Route::post('/generarLinea/{idTramite}', 'ArchivosController@generarLinea')->name('generarLinea');

//VENTANILLA AGUAS
Route::get('/ventanilla', 'Aguas\VentanillaController@index')->name('ventanillaHome');
Route::get('/storeVentanilla', 'Aguas\VentanillaController@store');
//Test
Route::post('/generarCertificadoTest/{idTramite}', 'TestController@generarCertificado');

